import 'package:yaml/yaml.dart';

import '../builders/builders.dart';
import '../configurations.dart';

extension YamlMapEnabled on YamlMap {
  SidecarExceptionTuple<bool?> parseEnabled() {
    const key = 'enabled';
    try {
      final enabledValue = containsKey(key) ? value[key] as bool : null;
      return SidecarExceptionTuple<bool?>(enabledValue, []);
    } catch (e) {
      return SidecarExceptionTuple<bool?>(null, [
        SidecarLintException(
          nodes.keys
              .cast<YamlScalar>()
              .firstWhere((element) => element.value == key),
          message: "Invalid value. Must be 'true' or 'false'",
        )
      ]);
    }
  }
}
